#pragma semicolon 1

#include <ws_store>
#include <sourcemod>

public Plugin:myinfo = 
{
	name	= "STORE (Health)",
	author	= "wS (World-Source.Ru)",
	version = "1.2"
};

new g_CategoryID, g_ItemID;
new g_Price, g_Limit, g_Count[MAXPLAYERS + 1];
new g_Health, g_HealthType;

public OnPluginStart()
{
	CreateTimer(1.0, START);
}

public OnPluginEnd()
{
	if (g_CategoryID > 0 && !STORE_DeleteCategoryByID(g_CategoryID, true) && g_ItemID > 0)
		STORE_RemoveItemFromCategory(g_CategoryID, g_ItemID);
}

public STORE_Loaded()
{
	g_CategoryID = 0; g_ItemID = 0;
	decl String:PluginName[150]; PluginName[0] = '\0'; GetPluginFilename(GetMyHandle(), PluginName, 150);
	ServerCommand("sm plugins reload \"%s\"", PluginName);
}

public Action:START(Handle:timer)
{
	/////
	new Handle:kv = CreateKeyValues("store_health");

	if (!FileToKeyValues(kv, "cfg/store/modules/store_health.txt"))
		SetFailState("Error in cfg/store/modules/store_health.txt");

	decl String:CategoryName[STORE_CATEGORY_LENGTH];
	KvGetString(kv, "CategoryName", CategoryName, STORE_CATEGORY_LENGTH);
	if (TrimString(CategoryName) < 1)
		SetFailState("Категория не указана");

	new bool:bCategoryExist = (g_CategoryID = STORE_GetCategoryID(CategoryName)) > 0;
	decl String:Text[STORE_ITEMTEXT_LENGTH], String:str_flag[10];

	if (!bCategoryExist)
	{
		KvGetString(kv, "CategoryText", Text, STORE_ITEMTEXT_LENGTH);
		KvGetString(kv, "CategoryFlag", str_flag, 10);

		if ((g_CategoryID = STORE_CreateCategory(CategoryName, Text, str_flag)) < 1)
			SetFailState("Не удалось создать категорию '%s'", CategoryName);
	}

	g_Price = KvGetNum(kv, "price");
	KvGetString(kv, "ItemText", Text, STORE_ITEMTEXT_LENGTH);
	if (TrimString(Text) > 0)
	{
		KvGetString(kv, "ItemFlag", str_flag, 10);
		if ((g_ItemID = STORE_AddItemToCategory(g_CategoryID, Text, g_Price, true, MyCallBack, str_flag)) < 1)
		{
			if (!bCategoryExist)
			{
				STORE_DeleteCategoryByID(g_CategoryID, true);
				g_CategoryID = 0;
			}
			SetFailState("Не удалось добавить функцию '%s'", Text);
		}
	}
	else if (bCategoryExist)
		SetFailState("Укажите уникальное название категории или используйте ItemText");

	g_Limit			= KvGetNum(kv, "round_limit");
	if ((g_Health	= KvGetNum(kv, "health")) < 1) g_Health = 1;
	g_HealthType	= KvGetNum(kv, "type");

	CloseHandle(kv);
	/////

	HookEvent("round_start", round_start, EventHookMode_PostNoCopy);
	return Plugin_Stop;
}


///


public MyCallBack(client, const String:steamid[], CategoryID, ItemID, ItemPrice)
{
	if (ItemID == g_ItemID)
		wS_OnClientSelect(client, LastMenuItem:MI_InCategory);
}

public STORE_OnClientSelectEmptyCategory(client, const String:steamid[], CategoryID)
{
	if (CategoryID == g_CategoryID)
		wS_OnClientSelect(client, LastMenuItem:MI_Main);
}

stock wS_OnClientSelect(client, LastMenuItem:MI)
{
	if (g_Limit > 0 && g_Count[client] >= g_Limit)
	{
		PrintCenterText(client, "Будет доступно в следующем раунде");
		STORE_ShowMenu(client, MI);
		return;
	}

	if (!IsPlayerAlive(client))
	{
		PrintCenterText(client, "Вы мертвы");
		STORE_ShowMenu(client, MI);
		return;
	}

	new CurrHp = GetEntProp(client, Prop_Send, "m_iHealth");
	if (g_HealthType == 1 && CurrHp >= g_Health)
	{
		PrintCenterText(client, "Вы и так здоровы");
		STORE_ShowMenu(client, MI);
		return;
	}

	if (g_Price > 0)
	{
		new credits = STORE_GetCredits(client);

		if (credits < g_Price)
		{
			PrintCenterText(client, "Вам не хватает %d кр", (g_Price - credits));
			STORE_ShowMenu(client, MI);
			return;
		}

		if (!STORE_SetCredits(client, (credits - g_Price)))
		{
			LogError("Не удалось установить кредиты игроку '%N'", client);
			return;
		}
	}

	g_Count[client]++;
	SetEntProp(client, Prop_Send, "m_iHealth", g_HealthType == 1 ? g_Health : (CurrHp + g_Health));

	STORE_ShowMenu(client, MI);
}


///


public round_start(Handle:event, const String:name[], bool:silent)
{
	for (new i = 1; i <= MaxClients; i++) g_Count[i] = 0;
}

public OnClientConnected(client)
{
	g_Count[client] = 0;
}